#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll INF = 3e18;

struct query {
    int r, i;
};

bool operator<(const query q1, const query q2) {
    return q1.r < q2.r;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;

    ll a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    ll k = 61;

    vector<ll> v[k];

    

    int p[n + 1] = {};
    for (int i = 1; i <= n; i++) {
        ll cur = a[i];
        while (cur % 2 == 0) {
            p[i]++;
            cur /= 2;
        }
        v[p[i]].push_back(i);
    }

    vector<query> quer[n + 1];

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        quer[l].push_back({r, i});
    }

    for (int i = 1; i <= n; i++) {
        sort(quer[i].begin(), quer[i].end());
    }


    int ind[k] = {};
    set<pair<ll, ll>> s;
    for (int i = 0; i < k; i++) {
        if (v[i].size() != 0) {
            s.insert({v[i][0], i});
        }
    }

    ll res[q];

    for (int i = 1; i <= n; i++) {
        auto it = s.begin();
        ll mask = 0;
        for (int j = 0; j < quer[i].size(); j++) {
            while (it != s.end() && it->first <= quer[i][j].r) {
                mask += (1LL << (it->second));
                it++;
            }

            int cur = 0;
            int ans = 0;

            for (int i = 0; i < k; i++) {
                if (mask & (1LL << i)) {
                    cur++;
                }
                else {
                    cur = 0;
                }
                ans = max(ans, cur);
            }

            res[quer[i][j].i] = ans;
        }

        s.erase({v[p[i]][ind[p[i]]], p[i]});
        ind[p[i]]++;
        
        if (v[p[i]].size() > ind[p[i]]) {
            s.insert({v[p[i]][ind[p[i]]], p[i]});
        }
    }

    for (int i = 0; i < q; i++) {
        printf("%lld\n", res[i] - 1);
    }
    



    

    
}
