#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <numeric>
#include <queue>
#include <unordered_map>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

const lli K = 65;

vector<lli> a;
vector<lli> res;
vector<lli> lefts;
vector<lli> leftb;
vector<lli> arrup[K];
vector<lli> arrdown[K];
vector<lli> arr[K];
unordered_map<lli, vector<lli>> mps;
unordered_map<lli, vector<lli>> mpb;
vector<lli> dv[K];


void build(lli u, lli l, lli r, lli ind)
{
    if (l == r) {
        dv[ind][u] = arr[ind][l];
        return;
    }
    lli m = (l + r) / 2;
    build(u * 2 + 1, l, m, ind);
    build(u * 2 + 2, m+1, r, ind);
    dv[ind][u] = min(dv[ind][u * 2 + 1], dv[ind][u * 2 + 2]);
}

lli get(lli u, lli tl, lli tr, lli l, lli r, lli ind)
{
    if (tl > r || tr < l)return 1e9;
    if (tl >= l && tr <= r)return dv[ind][u];
    lli tm = (tl + tr) / 2;
    return min(get(u * 2 + 1, tl, tm, l, r, ind), get(u * 2 + 2, tm + 1, tr, l, r, ind));
}

void solve()
{
    lli n, q;
    cin >> n >> q;
    a.resize(n + 1);
    res.resize(q + 1, 0);
    lefts.resize(n + 1,1e18);
    leftb.resize(n + 1,1e18);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) {
        mps[a[i]].push_back(i);
        mpb[a[i]].push_back(i);
        for (auto to : mps[a[i]*2])lefts[to] = i;
        mps[a[i] * 2].clear();
        if (a[i] % 2 == 0) {
            for (auto to : mpb[a[i] / 2])leftb[to] = i;
            mpb[a[i] / 2].clear();
        }
    }
    
    for (int i = 0; i < K; i++) {
        arrup[i].resize(n + 1,1e18);
        arrdown[i].resize(n + 1,1e18);
        arr[i].resize(n + 1,1e18);
        dv[i].resize(4 * n,1e18);
    }
    for (int i = 1; i <= n; i++) {
        lli tr = i;
        lli cnt = 0;
        while (tr <= n) {
            arrup[cnt][i] = tr;
            tr = leftb[tr];
            cnt++;
        }

        cnt = 0;
        tr = i;
        while (tr <= n) {
            arrdown[cnt][i] = tr;
            tr = lefts[tr];
            cnt++;
        }

        for (int j = 0; j < K; j++) {
            for (int k = 0; k < K; k++) {
                if (j+k<K)arr[j + k][i] = min(arr[j + k][i], max(arrup[j][i], arrdown[k][i]));
            }
        }
    }

    for (int i = 0; i < K; i++)build(0, 1, n, i);
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        lli tl = 0, tr = K - 1;
        while (tl < tr) {
            lli m = (tl + tr+1) / 2;
            if (get(0, 1, n, l, r, m) <= r)tl = m;
            else tr = m - 1;
        }
        cout << tl << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

