#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
using namespace std;
using ll = int;

constexpr ll INF = 1000000000LL;

ll n, m, q, k, x, y, a, b, c;
ll vec[60][500000];

struct segtree {
    array<int, 1048576> tr;

    segtree() {
    }

    void build(ll x, ll l, ll r, ll idx) {
        if (l == r) {
            tr[x] = vec[idx][l];
            return;
        }
        ll mid = (r + l) / 2;
        build(x * 2 + 1, l, mid, idx);
        build(x * 2 + 2, mid + 1, r, idx);
        tr[x] = max(tr[x * 2 + 1], tr[x * 2 + 2]);
    }

    void upd(ll x, ll l, ll r, ll idx, ll val) {
        if (l == r) {
            tr[x] = val;
            return;
        }
        ll mid = (r + l) / 2;
        if (idx <= mid) {
            upd(x * 2 + 1, l, mid, idx, val);
        }
        else {
            upd(x * 2 + 2, mid + 1, r, idx, val);
        }
        tr[x] = max(tr[x * 2 + 1], tr[x * 2 + 2]);
    }

    ll query(ll x, ll l, ll r, ll L, ll R) {
        if (r < l) {
            return -INF;
        }
        if (R < l) {
            return -INF;
        }
        if (r < L) {
            return -INF;
        }
        if (L <= l && r <= R) {
            return tr[x];
        }
        ll mid = (r + l) / 2;
        return max(query(x * 2 + 1, l, mid, L, R), query(x * 2 + 2, mid + 1, r, L, R));
    }
};

segtree sg[60];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // vector<long long> pool(1, 1);
    // while (pool[pool.size() - 1] * 2 <= (long long)INF * INF) {
    //     pool.push_back(pool[pool.size() - 1] * 2);
    // }

    cin>>n>>q;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        // v[i] = pool[rand() % (pool.size())];
        for (int j = 0; j < 60; j++) {
            vec[j][i] = -INF;
        }
    }
    map<long long, ll> mp;
    for (int i = 0; i < n; i++) {
        mp[v[i]] = i;
        vector<ll> merged;
        merged.reserve(60);
        merged.push_back(i);
        long long pos = v[i];
        ll mn = i;
        while ((pos & 1) == 0 && mp.count(pos >> 1)) {
            pos >>= 1;
            mn = min(mn, mp[pos]);
            merged.push_back(mn);
        }
        pos = v[i];
        mn = i;
        while (mp.count(pos << 1)) {
            pos <<= 1;
            // cout << pos << ' ';
            mn = min(mn, mp[pos]);
            merged.push_back(mn);
        }
        // cout << '\n';
        sort(merged.rbegin(), merged.rend());
        // cout << merged.size() << '\n';
        for (int j = 0; j < merged.size(); j++) {
            // cout << merged[j] << ' ';
            // sg[j].upd(0, 0, n - 1, i, merged[j]);
            vec[j][i] = merged[j];
        }
        // cout << '\n';
    }
    // return 0;
    for (int i = 0; i < 60; i++) {
        sg[i].build(0, 0, n - 1, i);
    }
    // return 0;
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        x--;
        y--;
        ll l = 0, r = 59;
        while (r > l) {
            ll mid = r - (r - l) / 2;
            if (sg[mid].query(0, 0, n - 1, x, y) >= x) {
                l = mid;
            }
            else {
                r = mid - 1;
            }
        }
        cout << l << '\n';
    }
}
