#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
typedef long long ll;

const ll md = 1'000'000'007;
vector<ll> x;
vector<int> k;
int un;
struct str {
	vector<vector<int>> tr;
	vector<int> mx;
	multiset<int> st;
	str() {
		tr.assign(un + 1, vector<int>(60));
		mx.assign(un + 1, 0);
		for (int i = 0; i <= un; i++)
			st.insert(0);
	}
	void ad(int i) {
		tr[x[i]][k[i]]++;
		int p = -1;
		st.erase(st.find(mx[x[i]]));
		for (int j = 0; j < 60; j++)
			if (tr[x[i]][j])
				mx[x[i]] = max(mx[x[i]], j - p);
			else
				p = j;
		st.insert(mx[x[i]]);
	}
	void erse(int i) {
		tr[x[i]][k[i]]--;
		int p = -1;
		st.erase(st.find(mx[x[i]]));
		mx[x[i]] = 0;
		for (int j = 0; j < 60; j++)
			if (tr[x[i]][j])
				mx[x[i]] = max(mx[x[i]], j - p);
			else
				p = j;
		st.insert(mx[x[i]]);
	}
	int fnd() {
		return (*st.rbegin());
	}
};
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int sz = 320;
	int n, q;
	cin >> n >> q;
	vector<ll> a(n);
	x.resize(n);
	k.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		k[i] = 0;
		while (a[i] % 2 == 0) {
			a[i] /= 2;
			k[i]++;
		}
		x[i] = a[i];
	}
	vector<ll> cp = x;
	sort(cp.begin(), cp.end());
	cp.resize(unique(cp.begin(), cp.end()) - cp.begin());
	un = cp.size();
	for (int i = 0; i < n; i++)
		x[i] = upper_bound(cp.begin(), cp.end(), x[i]) - cp.begin();
	vector<int> ans(q);
	vector<pair<int, int>> odp(q);
	vector<pair<pair<int, int>, int>> qu(q);
	vector<vector<pair<int, int>>> g(sz);
	for (int i = 0; i < q; i++) {
		cin >> qu[i].first.first >> qu[i].first.second;
		qu[i].first.first--;
		qu[i].first.second--;
		odp[i] = qu[i].first;
		qu[i].second = i;
		g[qu[i].first.first / sz].push_back({ qu[i].first.second, i });
	}

	str sm = str();
	for (int T = 0; T < sz; T++) {
		sort(g[T].begin(), g[T].end());
		if (g[T].size() == 0)
			continue;
		for (int i = odp[g[T][0].second].first; i <= g[T][0].first; i++)
			sm.ad(i);
		ans[g[T][0].second] = sm.fnd();
		int p1 = odp[g[T][0].second].first, p2 = g[T][0].first + 1;
		for (int i = 1; i < g[T].size(); i++) {
			int nw = g[T][i].second;
			while (p2 <= odp[nw].second) {
				sm.ad(p2);
				p2++;
			}
			while (p1 < odp[nw].first) {
				sm.erse(p1);
				p1++;
			}
			while (odp[nw].first < p1) {
				p1--;
				sm.ad(p1);
			}
			ans[nw] = sm.fnd();
		}
		for (int i = p1; i < p2; i++)
			sm.erse(i);
	}
	for (int w : ans)
		cout << w - 1 << "\n";
}