#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

const ll md = 1'000'000'007;

int main() 
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<vector<int>> datain(2, vector<int>(n));
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < n; j++)
			cin >> datain[i][j];
	vector<int> a(n * 2 + 1, -1);
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < n; j++) {
			int v = datain[i][j];
			//cin >> v;
			if (!v)
				continue;

			if (i && v < datain[i - 1][j]) {
				cout << "0\n";
				return 0;
			}
			if (j && v < datain[i][j - 1]) {
				cout << "0\n";
				return 0;
			}

			a[v - 1] = j + i * n;
			if (v == j * 2 + 1 && i) {
				cout << "0\n";
				return 0;
			}
		}
	a[2 * n - 1] = 2 * n - 1;
	vector<vector<int>> dp(2 * n + 1, vector<int>(n + 1));
	dp[0][0] = 1;
	for (int i = 1; i <= n * 2; i++) {
		if (a[i - 1] == -1) {
			for (int j = (i + 1) / 2; j <= n; j++)
				dp[i][j] = (dp[i - 1][j] + dp[i - 1][j - 1]) % md;
			continue;
		}
		int J;
		if (a[i - 1] < n)
			J = a[i - 1];
		else
			J = i - 1 - (a[i - 1] - n);
		if (a[i - 1] < n)
			dp[i][J + 1] = dp[i - 1][J];
		else
			dp[i][J] = dp[i - 1][J];
	}
	cout << dp[2 * n][n] << "\n";
}