#include <bits/stdc++.h>
using namespace std;

#define DIMN 800007
#define MOD 1000000007

int n;
vector<int> a[2];
long long f[DIMN];

void filfact() {
    f[0] = 1;
    for (int i = 1; i < DIMN; i++) {
        f[i] = (f[i-1]*i)%MOD;
    }
}

long long powmod (long long x, long long p) {
    long long res = 1;
    while (p > 0) {
        if (p%2) res*=x;
        res%=MOD;
        x*=x;
        x%=MOD;
        p/=2;
    }
    return res;
}

int solve_empty(int a, int b) {
    //cout << a << " " << b << endl;
    if (a < b) swap(a,b);
    int x = a-b, y = b;
    long long res = (f[x+2*y]*(x+1))%MOD;
    res = (res*powmod(f[x+y+1],MOD-2))%MOD;
    res = (res*powmod(f[y],MOD-2))%MOD;
    return res;
}

int solve() {
    for (int i = 0; i < n; i++) {
        if (a[0][i]!=0) {
            //cout << a[0][i] << "a ";
            if (a[0][i] > 2*i+1) return 0;
            return (solve_empty(i,a[0][i]-i-1)*solve_empty(n-i-1,n-(a[0][i]-i-1)))%MOD;
        }
    }
    for (int i = 0; i < n; i++) {
        if (a[1][i]!=0) {
            //cout << a[0][i] << "a ";
            if (a[1][i]-1 <= 2*i) return 0;
            return (solve_empty(a[1][i]-i-1,i)*solve_empty(n-(a[1][i]-i-1),n-i-1))%MOD;
        }
    }
    return solve_empty(n,n);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    filfact();

    cin>>n;
    a[0].resize(n);
    a[1].resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[0][i];
    }
    for (int i = 0; i < n; i++) {
        cin >> a[1][i];
    }
    cout << solve();

}
