#include <bits/stdc++.h>

#define ll long long

using namespace std;


const int n_max = 10;

struct Node {
    ll val;
    int ind;
    int l;
    int r;
};

Node tree[4*n_max];
ll a[n_max] = {0LL};
ll mxs[n_max];

void buildTree(int v)
{
    if (tree[v].l == tree[v].r) {
        tree[v].val = a[tree[v].l];
        tree[v].ind = tree[v].l;
        return;
    }
    tree[2*v].l = tree[v].l;
    tree[2*v].r = (tree[v].l+tree[v].r)/2;
    tree[2*v+1].l = tree[2*v].r+1;
    tree[2*v+1].r = tree[v].r;
    buildTree(2*v);
    buildTree(2*v+1);
    tree[v].val = max(tree[2*v].val, tree[2*v+1].val);
}

int find(int v, int ind)
{
    if (tree[v].l == tree[v].r) {
        if (tree[v].l == ind) return v;
        else return -1;
    } else {
        if (ind <= (tree[v].l+tree[v].r)/2) return find(2*v,ind);
        else return find(2*v+1, ind);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, t;
    cin>>n>>m>>t;
    for (int i=0;i<n;++i) {
        cin>>a[i];
    }
    
    tree[1].l = 0;
    tree[1].r = n-1;
    buildTree(1);
    
    int l, r, cnt;
    for (int i=0;i<m;++i) {
        cin>>l>>r;
        --l;
        --r;
        int v = find(1, l);
        ll mx = tree[v].val;
        cnt = 1;
        while (l < r) {
            if (max(tree[v].val, mx) == mx) {
                if (tree[v/2].r == tree[v].r && tree[v/2].val>mx) {
                    ++v;
                } else if (tree[v].r >= r) {
                    mxs[cnt-1] = r-l+1;
                    l = r;
                } else {
                    v >>= 1;
                }
            } else {
                if (tree[v].l == tree[v].r) {
                    mxs[cnt-1] = tree[v].ind-l;
                    if (tree[v].l<=r)++cnt;
                    if (tree[v].ind == r) {
                        mxs[cnt-1] = 1;
                    }
                    l = tree[v].ind;
                    mx = tree[v].val;
                } else {
                    v <<= 1;
                    if (tree[v].val <= mx) ++v;
                }
            }
        }
        ll res = 0;
        if (t == 1) {
            for (int i=0;i<cnt-1;++i) {
                for (int j=i+1;j<cnt;++j) {
                    res += (j-i+1)*mxs[i]*mxs[j];
                    res %= 1000000007;
                }
                res += mxs[i]*(mxs[i]+1)/2;
                res %= 1000000007;
            }
            res += mxs[cnt-1]*(mxs[cnt-1]+1)/2;
            res %= 1000000007;
        } else {
            for (int i=0;i<cnt-1;++i) {
                for (int j=i+1;j<cnt;++j) {
                    res += (j-i+1)*(j-i+1)*mxs[i]*mxs[j];
                    res %= 1000000007;
                }
                res += mxs[i]*(mxs[i]+1)/2;
                res %= 1000000007;
            }
            res += mxs[cnt-1]*(mxs[cnt-1]+1)/2;
            res %= 1000000007;
        }
        cout<<res<<'\n';
    }
}
