#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll INF = 3e18;

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,lzcnt")


struct query {
    int l, r, i, b;
};

bool operator<(const query q1, const query q2) {
    return q1.b < q2.b || q1.b == q2.b && q1.r < q2.r;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;

    ll a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    int B = sqrt(n);

    ll b[n + 1];
    ll c[n + 1];

    int p[n + 1] = {};

    map<ll, bool> seen;

    for (int i = 1; i <= n; i++) {
        ll cur = a[i];
        while (cur % 2 == 0) {
            p[i]++;
            cur /= 2;
        }
        b[i] = cur;
        if (seen.count(cur) == 0) {
            c[i] = cur;
            seen[cur] = true;
        }
        else {
            c[i] = INF;
        }
    }

    sort(c + 1, c + n + 1);

    ll m = 0;

    for (int i = 1; i <= n; i++) {
        a[i] = lower_bound(c + 1, c + n + 1, b[i]) - c;
        m = max(m, a[i]);
    }


    query quer[q];

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;

        quer[i] = {l, r, i, l / B};
    }

    sort(quer, quer + q);

    int k = 62;


    int cnt[m + 1][k] = {};

    int res[k] = {};

    set<pair<int, int>> ones[m + 1];

    int l = quer[0].l, r = quer[0].l - 1;

    int ans[q];

    for (int i = 0; i < q; i++) {
        if (i != 0 && quer[i].b != quer[i - 1].b) {
            fill(res, res + k, 0);
            for (int j = 1; j <= m; j++) {
                ones[j].clear();
                fill(cnt[j], cnt[j] + k, 0);
            }
            l = quer[i].l, r = quer[i].l - 1;
        }
        
        while (r < quer[i].r) {
            r++;
            cnt[a[r]][p[r]]++;
            if (cnt[a[r]][p[r]] == 1) {
                bool have1 = p[r] != 0 && cnt[a[r]][p[r] - 1] > 0;
                bool have2 = p[r] != k - 1 && cnt[a[r]][p[r] + 1] > 0;
                if (!have1 && !have2) {
                    ones[a[r]].insert({p[r], 1});
                    res[1]++;
                }
                else if (have1 && !have2) {
                    auto itt = prev(ones[a[r]].lower_bound({p[r], -1}));
                    pair<int, int> it = {itt->first, itt->second};
                    ones[a[r]].erase(itt);
                    ones[a[r]].insert({it.first, it.second + 1});
                    res[it.second]--;
                    res[it.second + 1]++;
                }
                else if (!have1 && have2) {
                    auto itt = ones[a[r]].lower_bound({p[r] + 1, -1});
                    pair<int, int> it = {itt->first, itt->second};
                    ones[a[r]].erase(itt);
                    ones[a[r]].insert({p[r], it.second + 1});
                    res[it.second]--;
                    res[it.second + 1]++;
                }
                else {
                    auto itt1 = prev(ones[a[r]].lower_bound({p[r], -1}));
                    pair<int, int> it1 = {itt1->first, itt1->second};
                    auto itt2 = ones[a[r]].lower_bound({p[r] + 1, -1});
                    pair<int, int> it2 = {itt2->first, itt2->second};
                    ones[a[r]].erase(itt1);
                    ones[a[r]].erase(itt2);
                    ones[a[r]].insert({it1.first, it1.second + it2.second + 1});
                    res[it1.second]--;
                    res[it2.second]--;
                    res[it1.second + it2.second + 1]++;
                }
            }
        }


        while (l > quer[i].l) {
            l--;
            cnt[a[l]][p[l]]++;
            if (cnt[a[l]][p[l]] == 1) {
                bool have1 = p[l] != 0 && cnt[a[l]][p[l] - 1] > 0;
                bool have2 = p[l] != k - 1 && cnt[a[l]][p[l] + 1] > 0;
                if (!have1 && !have2) {
                    ones[a[l]].insert({p[l], 1});
                    res[1]++;
                }
                else if (have1 && !have2) {
                    auto itt = prev(ones[a[l]].lower_bound({p[l], -1}));
                    pair<int, int> it = {itt->first, itt->second};
                    ones[a[l]].erase(itt);
                    ones[a[l]].insert({it.first, it.second + 1});
                    res[it.second]--;
                    res[it.second + 1]++;
                }
                else if (!have1 && have2) {
                    auto itt = ones[a[l]].lower_bound({p[l] + 1, -1});
                    pair<int, int> it = {itt->first, itt->second};
                    ones[a[l]].erase(itt);
                    ones[a[l]].insert({p[l], it.second + 1});
                    res[it.second]--;
                    res[it.second + 1]++;
                }
                else {
                    auto itt1 = prev(ones[a[l]].lower_bound({p[l], -1}));
                    pair<int, int> it1 = {itt1->first, itt1->second};
                    auto itt2 = ones[a[l]].lower_bound({p[l] + 1, -1});
                    pair<int, int> it2 = {itt2->first, itt2->second};
                    ones[a[l]].erase(itt1);
                    ones[a[l]].erase(itt2);
                    ones[a[l]].insert({it1.first, it1.second + it2.second + 1});
                    res[it1.second]--;
                    res[it2.second]--;
                    res[it1.second + it2.second + 1]++;
                }
            }
        }

        while (l < quer[i].l) {
            cnt[a[l]][p[l]]--;
            if (cnt[a[l]][p[l]] == 0) {
                auto itt = prev(ones[a[l]].lower_bound({p[l] + 1, -1}));
                pair<int, int> it = {itt->first, itt->second};
                int left = it.first;
                int right = it.first + it.second - 1;
                ones[a[l]].erase(itt);
                if (left != p[l]) {
                    ones[a[l]].insert({left, p[l] - left});
                    res[p[l] - left]++;
                }
                if (right != p[l]) {
                    ones[a[l]].insert({p[l] + 1, right - p[l]});
                    res[right - p[l]]++;
                }
                res[right - left + 1]--;
            }
            l++;
        }



        int here = 0;
        for (int i = k - 1; i >= 0; i--) {
            if (res[i] > 0) {
                here = i;
                break;
            }
        }
        ans[quer[i].i] = here - 1;
    }

    for (int i = 0; i < q; i++) {
        printf("%i\n", ans[i]);
    }
    
}
