#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <numeric>
#include <queue>
#include <unordered_map>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

const lli K = 65;

vector<lli> a;
vector<lli> res;
vector<lli> lefts;
vector<lli> leftb;
vector<lli> arrup[K];
vector<lli> arrdown[K];
vector<lli> arr[K];
unordered_map<lli, vector<lli>> mps;
unordered_map<lli, vector<lli>> mpb;
vector<lli> dv[K];



lli BSIZE = 800;

struct myq
{
    lli l, r, ind;
};


vector<myq> qq;
lli s[120];
unordered_map<lli, lli> mp;
unordered_map<lli, lli> tres;

bool cmp(myq q1, myq q2)
{
    if (q1.l / BSIZE == q2.l / BSIZE)return q1.r < q2.r;
    return q1.l / BSIZE < q2.l / BSIZE;
}



void add(lli ind)
{
    lli val = a[ind];
    mp[val]++;
    tres[val] = tres[val * 2] + 1;
    if (mp[val] == 1) {
        lli x = tres[val];
        s[x]++;
        while (val % 2 == 0) {
            val /= 2;
            x++;
            if (mp[val] == 0)break;
            s[tres[val]]--;
            tres[val] = x;
            s[x]++;
        }
    }
}

void del(lli ind)
{
    lli val = a[ind];
    mp[val]--;
    if (mp[val] == 0) {
        lli x = 0;
        s[tres[val]]--;
        tres[val] = 0;
        while (val % 2 == 0) {
            val /= 2;
            x++;
            if (mp[val] == 0)break;
            s[tres[val]]--;
            s[x]++;
            tres[val] = x;
        }
    }
}


void solve2(lli n,lli q)
{
    a.resize(n + 1);
    res.resize(q + 1, 0);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        qq.push_back({ l,r,i });
    }
    sort(qq.begin(), qq.end(), cmp);
    lli tl = 1, tr = 0;
    for (auto to : qq) {
        while (tr < to.r)add(++tr);
        while (tl > to.l)add(--tl);

        while (tr > to.r)del(tr--);
        while (tl < to.l)del(tl++);

        for (int i = 65; i >= 1; i--) {
            if (s[i] > 0) {
                res[to.ind] = i - 1;
                break;
            }
        }
    }
    for (int i = 1; i <= q; i++)cout << res[i] << LF;
}


void build(lli u, lli l, lli r, lli ind)
{
    if (l == r) {
        dv[ind][u] = arr[ind][l];
        return;
    }
    lli m = (l + r) / 2;
    build(u * 2 + 1, l, m, ind);
    build(u * 2 + 2, m+1, r, ind);
    dv[ind][u] = min(dv[ind][u * 2 + 1], dv[ind][u * 2 + 2]);
}

lli get(lli u, lli tl, lli tr, lli l, lli r, lli ind)
{
    if (tl > r || tr < l)return 1e9;
    if (tl >= l && tr <= r)return dv[ind][u];
    lli tm = (tl + tr) / 2;
    return min(get(u * 2 + 1, tl, tm, l, r, ind), get(u * 2 + 2, tm + 1, tr, l, r, ind));
}

void solve()
{
    lli n, q;
    cin >> n >> q;
    if (n > 3000) {
        solve2(n, q);
        return;
    }
    a.resize(n + 1);
    res.resize(q + 1, 0);
    lefts.resize(n + 1,1e9);
    leftb.resize(n + 1,1e9);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) {
        mps[a[i]].push_back(i);
        mpb[a[i]].push_back(i);
        for (auto to : mps[a[i]*2])lefts[to] = i;
        mps[a[i] * 2].clear();
        if (a[i] % 2 == 0) {
            for (auto to : mpb[a[i] / 2])leftb[to] = i;
            mpb[a[i] / 2].clear();
        }
    }
    
    for (int i = 0; i < K; i++) {
        arrup[i].resize(n + 1,1e9);
        arrdown[i].resize(n + 1,1e9);
        arr[i].resize(n + 1,1e9);
        dv[i].resize(4 * n);
    }
    for (int i = 1; i <= n; i++) {
        lli tr = i;
        lli cnt = 0;
        while (tr <= n) {
            arrup[cnt][i] = tr;
            tr = leftb[tr];
            cnt++;
        }

        cnt = 0;
        tr = i;
        while (tr <= n) {
            arrdown[cnt][i] = tr;
            tr = lefts[tr];
            cnt++;
        }

        for (int j = 0; j < K; j++) {
            for (int k = 0; k < K; k++) {
                if (j+k<K)arr[j + k][i] = min(arr[j + k][i], max(arrup[j][i], arrdown[k][i]));
            }
        }
    }

    for (int i = 0; i < K; i++)build(0, 1, n, i);
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        for (int j = K-1; j >= 0; j--) {
            if (get(0, 1, n, l, r, j) <= r) {
                cout << j << LF;
                break;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

