#include<bits/stdc++.h>

using namespace std;

const int dim = 5e5+7, dim2 = 30;

struct query{
    int L, R, num;
};

long long n, q, res;
long long a[dim], d2[dim], ans[dim];
map<long long, multiset<int>> m;
set<int> maxr;
query Q[dim];

void solve(int x){

    d2[x] = 0;
    long long p;
    for(int i = dim2; i>0; i--){
        p = pow(2, i);
        if(a[x]%p==0){
            a[x]/=p;
            d2[x]+=i;
        }
    }
}

bool cmp(query q1, query q2){
    if(q1.L!=q2.L)return q1.L<q2.L;
    else return q1.R<q2.R;
}

void add(int x){
    m[a[x]].insert(d2[x]);

    long long tmp;
    if(m[a[x]].size()>1)tmp = *m[a[x]].rbegin()-*m[a[x]].begin();
    else tmp = 0;
    //cout << "tmp: " << a[x] << " " << tmp << " " << res << endl;
    if(tmp>res){
        while(!maxr.empty())maxr.erase(maxr.begin());
        maxr.insert(a[x]);
    }
    if(tmp==res)maxr.insert(a[x]);
    if(m[a[x]].size()>tmp)res = max(res, tmp);
}

void sub(int x){
    if(m[a[x]].find(d2[x])!=m[a[x]].end())m[a[x]].erase(m[a[x]].find(d2[x]));
    long long tmp;
    if(m[a[x]].size()>1)tmp = *m[a[x]].rbegin()-*m[a[x]].begin();
    else tmp = 0;
    if(tmp>res){
        while(!maxr.empty())maxr.erase(maxr.begin());
        maxr.insert(a[x]);
        if(m[a[x]].size()>tmp)res = max(res, tmp);
    }
    else if(tmp==res){
        maxr.insert(a[x]);
        if(m[a[x]].size()>tmp)res = max(res, tmp);
    }
    else{
        if(!maxr.empty()){
            if(maxr.find(a[x])!=maxr.end())maxr.erase(maxr.find(a[x]));
        }
        res = tmp;
    }

}

void print(int curL, int curR){
    cout << curL << " " << curR << endl;

    cout << "!!!!! " << endl;

    for(auto t : m){
        for(auto to : t.second){
            cout << t.first << " " << to << endl;
        }
    }
    cout << "////" << endl;
    for(auto t : maxr){
        cout << t << endl;
    }
    cout << "???? res: " << res << endl;

}

int main(){

    cin >> n >> q;
    for(int i = 1; i<=n; i++){
        cin >> a[i];
        solve(i);
    }

    for(int i = 1; i<=q; i++){
        cin >> Q[i].L >> Q[i].R;
        Q[i].num = i;
    }
    sort(Q+1, Q+1+q, cmp);

    int L, R, curL = 1, curR = 1;
    res = 0; add(1);

    for(int i = 1; i<=q; i++){
        L = Q[i].L, R = Q[i].R;

        while(L<curL){
            add(--curL);
            //cout << "L<--" << endl;
            //print(curL, curR);
        }
        while(L>curL){
            sub(curL++);
            //cout << "L-->" << endl;
            //print(curL, curR);
        }

        while(R<curR){
            sub(curR--);
            //cout << "R<--" << endl;
            //print(curL, curR);
        }
        while(R>curR){
            add(++curR);
            //cout << "R-->" << endl;
            //print(curL, curR);
        }


        ans[Q[i].num] = res;
    }

    for(int i = 1; i<=q; i++)cout << ans[i] << endl;

    return 0;
}


