#include <iostream>

using namespace std;

#define MOD 1000000007

int** dp;
int* initial_row1;
int* initial_row2;

int main() {
    int length;
    cin >> length;

    dp = new int*[length + 1];
    initial_row1 = new int[length];
    initial_row2 = new int[length];

    for (int i = 0; i < length; i++) {
        cin >> initial_row1[i];
    }

    for (int i = 0; i < length; i++) {
        cin >> initial_row2[i];
    }

    for (int i = 1; i <= length; i++) {
        dp[i] = new int[i + 1];
        dp[i][0] = 1;

        for (int j = 1; j < i; j++) {
            dp[i][j] = 0;

            if (initial_row2[j - 1] == 0 || initial_row2[j - 1] == i + j) {
                dp[i][j] += dp[i][j - 1];
            }

            if (initial_row1[i - 1] == 0 || initial_row2[i - 1] == i + j) {
                dp[i][j] = dp[i - 1][j];
            }

            dp[i][j] %= MOD;
        }

        dp[i][i] = 0;

        if (initial_row2[i] == i * 2) {
            dp[i][i] = dp[i][i - 1];
        }
    }

    cout << dp[length][length] << "\n";

    return 0;
}
