#include <bits/stdc++.h>
typedef long double ld;
typedef long long ll;
using namespace std;
const ll INF = 1000000;
ll a[INF];
ll tree[INF*4];
ll build(ll l, ll r, ll v){
    if(l==r){
        tree[v]=(1<<a[l]);
        return tree[v];
    }
    ll middle = (l+r)/2;
    tree[v]=build(l, middle, v*2+1)|build(middle+1, r, v*2+2);
    return tree[v];
}
ll answer(ll l, ll r, ll left, ll right, ll v){
    if(right<l || left>r) return 0;
    if(left<=l && r<=right) return tree[v];
    ll middle = (l+r)/2;
    return answer(l, middle, left, right, v*2+1)|answer(middle+1, r, left, right, v*2+2);
}
int main(){
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    ll n, q;
    cin >> n >> q;
    for(ll i = 0; i<n; i++){
        ll value;
        cin >> value;
        ll now = 1;
        ll count = 0;
        while(now!=value){
            count++;
            now*=2;
        }
        a[i]=count;
    }
    build(0, n-1, 0);
    for(ll i = 0; i<q; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        ll temp = tree[0];
        ll answer = 0;
        ll count = 0;
        for(ll j = 0; j<64; j++){
            if(temp&(1LL<<j)) count++;
            else count = 0;
            answer=max(count-1, answer);
        }
        cout << answer;
    }
}